﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using VimTube.Data;

namespace VimTube.Migrations
{
    [DbContext(typeof(VimTubeContext))]
    [Migration("20200422204550_VimTubeCoreApp")]
    partial class VimTubeCoreApp
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.3")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("VimTube.Entities.Category", b =>
                {
                    b.Property<int>("IdCategory")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(50)")
                        .HasMaxLength(50);

                    b.HasKey("IdCategory");

                    b.HasIndex("Name")
                        .IsUnique();

                    b.ToTable("CATEGORIES");
                });

            modelBuilder.Entity("VimTube.Entities.Role", b =>
                {
                    b.Property<int>("IdRole")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("RoleType")
                        .IsRequired()
                        .HasColumnType("nvarchar(450)");

                    b.HasKey("IdRole");

                    b.HasIndex("RoleType")
                        .IsUnique();

                    b.ToTable("ROLES");

                    b.HasData(
                        new
                        {
                            IdRole = 1,
                            RoleType = "ADMIN"
                        },
                        new
                        {
                            IdRole = 2,
                            RoleType = "VIEWER"
                        });
                });

            modelBuilder.Entity("VimTube.Entities.User", b =>
                {
                    b.Property<int>("IdUser")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasColumnType("nvarchar(59)")
                        .HasMaxLength(59);

                    b.Property<int>("IdRole")
                        .HasColumnType("int");

                    b.Property<byte[]>("PasswordHash")
                        .IsRequired()
                        .HasColumnType("varbinary(130)")
                        .HasMaxLength(130);

                    b.Property<byte[]>("PasswordSalt")
                        .IsRequired()
                        .HasColumnType("varbinary(258)")
                        .HasMaxLength(258);

                    b.Property<string>("Username")
                        .IsRequired()
                        .HasColumnType("nvarchar(59)")
                        .HasMaxLength(59);

                    b.HasKey("IdUser");

                    b.HasIndex("Email")
                        .IsUnique();

                    b.HasIndex("IdRole");

                    b.HasIndex("Username")
                        .IsUnique();

                    b.ToTable("USERS");

                    b.HasData(
                        new
                        {
                            IdUser = 1,
                            Email = "lucas@hotmail.com",
                            IdRole = 1,
                            PasswordHash = new byte[] { 235, 165, 196, 34, 50, 148, 130, 120, 46, 224, 19, 198, 108, 177, 102, 46, 50, 96, 88, 203, 83, 77, 81, 68, 164, 38, 229, 42, 220, 97, 246, 61, 199, 169, 135, 22, 218, 157, 206, 184, 76, 82, 206, 192, 25, 224, 87, 169, 197, 25, 41, 49, 37, 134, 117, 4, 49, 110, 191, 65, 220, 135, 2, 114 },
                            PasswordSalt = new byte[] { 90, 105, 7, 223, 66, 165, 209, 89, 7, 235, 18, 183, 0, 77, 17, 130, 114, 169, 223, 223, 199, 44, 238, 14, 241, 217, 42, 98, 183, 47, 234, 32, 172, 117, 208, 9, 22, 122, 232, 8, 19, 101, 13, 129, 141, 46, 79, 239, 56, 216, 118, 126, 173, 178, 196, 134, 55, 27, 39, 142, 205, 145, 122, 101, 167, 229, 203, 71, 97, 225, 230, 175, 227, 249, 78, 87, 199, 62, 182, 109, 154, 63, 208, 15, 193, 190, 20, 147, 51, 234, 100, 120, 195, 199, 133, 36, 191, 170, 168, 13, 216, 59, 80, 224, 7, 120, 69, 176, 105, 233, 71, 240, 201, 14, 151, 242, 189, 106, 64, 140, 147, 61, 157, 147, 241, 130, 237, 222 },
                            Username = "Lucas"
                        },
                        new
                        {
                            IdUser = 2,
                            Email = "david@hotmail.com",
                            IdRole = 2,
                            PasswordHash = new byte[] { 239, 177, 196, 197, 147, 185, 57, 30, 58, 185, 230, 145, 5, 176, 1, 44, 235, 1, 17, 109, 248, 148, 156, 234, 92, 240, 242, 178, 127, 193, 255, 175, 1, 107, 37, 163, 247, 216, 43, 83, 173, 252, 161, 147, 76, 4, 53, 155, 183, 160, 210, 191, 206, 42, 241, 19, 237, 242, 216, 204, 121, 94, 28, 206 },
                            PasswordSalt = new byte[] { 90, 105, 7, 223, 66, 165, 209, 89, 7, 235, 18, 183, 0, 77, 17, 130, 114, 169, 223, 223, 199, 44, 238, 14, 241, 217, 42, 98, 183, 47, 234, 32, 172, 117, 208, 9, 22, 122, 232, 8, 19, 101, 13, 129, 141, 46, 79, 239, 56, 216, 118, 126, 173, 178, 196, 134, 55, 27, 39, 142, 205, 145, 122, 101, 167, 229, 203, 71, 97, 225, 230, 175, 227, 249, 78, 87, 199, 62, 182, 109, 154, 63, 208, 15, 193, 190, 20, 147, 51, 234, 100, 120, 195, 199, 133, 36, 191, 170, 168, 13, 216, 59, 80, 224, 7, 120, 69, 176, 105, 233, 71, 240, 201, 14, 151, 242, 189, 106, 64, 140, 147, 61, 157, 147, 241, 130, 237, 222 },
                            Username = "David"
                        });
                });

            modelBuilder.Entity("VimTube.Entities.Video", b =>
                {
                    b.Property<int>("IdVideo")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("nvarchar(250)")
                        .HasMaxLength(250);

                    b.Property<int>("Duration")
                        .HasColumnType("int");

                    b.Property<int>("IdCategory")
                        .HasColumnType("int");

                    b.Property<bool>("IsAgeRestricted")
                        .HasColumnType("bit");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(50)");

                    b.Property<DateTime>("UploadedDate")
                        .HasColumnType("datetime2");

                    b.HasKey("IdVideo");

                    b.HasIndex("IdCategory");

                    b.ToTable("VIDEOS");
                });

            modelBuilder.Entity("VimTube.Entities.User", b =>
                {
                    b.HasOne("VimTube.Entities.Role", "Role")
                        .WithMany("Users")
                        .HasForeignKey("IdRole")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("VimTube.Entities.Video", b =>
                {
                    b.HasOne("VimTube.Entities.Category", "Category")
                        .WithMany("Videos")
                        .HasForeignKey("IdCategory")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
